#ifndef _MLIBJPG_H
#define _MLIBJPG_H

#ifdef MLIBJPG_EXPORTS
#define MLIBJPG_API __declspec(dllexport)
#else
#define MLIBJPG_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	int width;
	int height;
	int bpp;
	int num_palette;
	RGBQUAD *palette;
} LoadJPGInfo, *lpLoadJPGInfo;

typedef struct {
	int width;
	int height;
	int bpp;
	int quality;
	BOOL force_baseline;
	BOOL progressive;
	int out_buffer_size; // read only
} SaveJPGInfo, *lpSavePGInfo;


MLIBJPG_API int LoadJPG(const char *filename, 
		int (*header_callback)(LoadJPGInfo *info, void *data), 
		void *(*read_callback)(int line_number, void *data),
		void *data);

MLIBJPG_API int SaveJPG(const char *filename, 
		SaveJPGInfo *info,
		void *(*write_callback)(int line_number, void *data),
		void *data);

MLIBJPG_API int LoadJPGFromMemory(void *memory, int memory_size,
		int (*header_callback)(LoadJPGInfo *info, void *data), 
		void *(*read_callback)(int line_number, void *data),
		void *data);

MLIBJPG_API int SaveJPGToMemory(
		SaveJPGInfo *info,
		void *(*memory_callback)(int required_size, void *data),
		void *(*write_callback)(int line_number, void *data),
		void *data);

// for GetProcAddress()
typedef MLIBJPG_API int lpLoadJPG(const char *filename, 
		int (*header_callback)(LoadJPGInfo *info, void *data), 
		void *(*read_callback)(int line_number, void *data),
		void *data);

typedef MLIBJPG_API int lpSaveJPG(const char *filename, 
		SaveJPGInfo *info,
		void *(*write_callback)(int line_number, void *data),
		void *data);

typedef MLIBJPG_API int lpLoadJPGFromMemory(void *memory, int memory_size,
		int (*header_callback)(LoadJPGInfo *info, void *data), 
		void *(*read_callback)(int line_number, void *data),
		void *data);

typedef MLIBJPG_API int lpSaveJPGToMemory(
		SaveJPGInfo *info,
		void *(*memory_callback)(int required_size, void *data),
		void *(*write_callback)(int line_number, void *data),
		void *data);


#ifdef __cplusplus
};
#endif

#endif //_MLIBJPG_H
